//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "DelDocsDlg.h"
#include "mixmaster.h"
#include "PgpMail.h"
#include "FileMan.h"
#include "global.h"
#include "helpdlgs.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TRemailerDocsDlg *RemailerDocsDlg;
TDeleteDocsDlg *DeleteDocsDlg;
TOpenDocsDlg *OpenDocsDlg;
//---------------------------------------------------------------------------
AnsiString __fastcall ClearChosenDocuments(TForm *Owner)
{
   DeleteDocsDlg = new TDeleteDocsDlg(Owner);
   CenterDialog(DeleteDocsDlg,Owner);
   DeleteDocsDlg->ShowModal();
   AnsiString files = DeleteDocsDlg->files;
   delete DeleteDocsDlg;
   return files;
}
//---------------------------------------------------------------------------
AnsiString __fastcall OpenChosenDocuments(TForm *Owner)
{
   OpenDocsDlg = new TOpenDocsDlg(Owner);
   CenterDialog(OpenDocsDlg,Owner);
   OpenDocsDlg->ShowModal();
   AnsiString files = OpenDocsDlg->files;
   delete OpenDocsDlg;
   return files;
}
//---------------------------------------------------------------------------
__fastcall TRemailerDocsDlg::TRemailerDocsDlg(TComponent* Owner)
  : TForm(Owner)
{
   AnsiString md=MixDir();
   bool errcheck=GetAppIni(StatsErrCheck,"").ToIntDef(1);
   Label1->Caption = "generic remailer documents dialog";
   Caption = "Remailer documents...";
   if (!FileExists(md+MListTxt)) MlistBox->Enabled = false;
   if (!FileExists(md+MRingTxt)) MRingBox->Enabled = false;
   if (!FileExists(md+MTyp2Txt)) Type2Box->Enabled = false;
   if (!FileExists(md+CListTxt)) ClistBox->Enabled = false;
   if (!FileExists(md+CRingTxt)) CRingBox->Enabled = false;
   if (!FileExists(md+CTyp1Txt)) CTyp1Box->Enabled = false;

   if (!errcheck) CTyp1Box->Visible = false;
   if (!HasPgp())
   {
      CTyp1Box->Visible = false;
      ClistBox->Visible = false;
      CRingBox->Visible = false;
      Bevel1->Visible = false;
      MlistBox->Left = 120;
      MRingBox->Left = 120;
      Type2Box->Left = 120;
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDocsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      AnsiString md=MixDir();
      if (MlistBox->Checked) files += mlisttxt+"\n";
      if (MRingBox->Checked) files += mringtxt+"\n";
      if (Type2Box->Checked) files += mtyp2txt+"\n";
      if (ClistBox->Checked) files += clisttxt+"\n";
      if (CRingBox->Checked) files += cringtxt+"\n";
      if (CTyp1Box->Checked) files += ctyp1txt+"\n";
      if (Tag==dtag && !files.IsEmpty())
      {
         if (MsgBoxHwnd(Handle,"Delete the selected documents?","Confirm",
            MB_OKCANCEL)==IDCANCEL)
         {
            CanClose = false;
            files = "";
         }
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDocsDlg::HelpBtnClick(TObject *Sender)
{
   switch (Tag)
   {
      case dtag: OpenHelp("RemailerClear","Deleteing Remailer Documents","",this); break;
      case otag: OpenHelp("RemailerOpen","Opening Remailer Documents","",this); break;
   }
}
//---------------------------------------------------------------------------
__fastcall TOpenDocsDlg::TOpenDocsDlg(TComponent *Owner)
  : TRemailerDocsDlg(Owner)
{
   Caption = "Open documents...";
   Label1->Caption =
      s("Check the documents you wish to open. Docs checked here ")+
      s("will replace docs with same name already open.");
   Tag = otag;
}
//---------------------------------------------------------------------------
__fastcall TDeleteDocsDlg::TDeleteDocsDlg(TComponent *Owner)
  : TRemailerDocsDlg(Owner)
{
   AnsiString md=MixDir();
   Caption = "Remove documents...";
   Label1->Caption =
      s("Check the documents you wish to delete from the system.");
   Tag = dtag;
}
//---------------------------------------------------------------------------
