//---------------------------------------------------------------------------
#ifndef PgpTestDlgsH
#define PgpTestDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include "PgpTestBufs.h"
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------

// read various pgp packets
bool __fastcall ParsePublicKeyPacket(BUFFER *packet,
   int &version, int &unixtime, int &validity, int &algorithm,
   AnsiString &idtext8);


class TPgpTestDlg : public TForm
{
__published:	// IDE-managed Components
	TMemo *Memo1;
	TBevel *Bevel1;
	TLabel *Label1;
	TButton *OkBtn;
	TButton *CloseBtn;
	TComboBox *ComboBox1;
	TTreeView *KeyList;
	TTimer *Timer1;
	TSpeedButton *ExpandBtn;
	void __fastcall CloseBtnClick(TObject *Sender);
	void __fastcall OkBtnClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall ComboBox1Change(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall ExpandBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    TTreeNode *main;
    TStringList *packets;
	__fastcall TPgpTestDlg(TComponent* Owner);
    void __fastcall GenBinaryNumbers();
    void __fastcall ScanKeyring(AnsiString &Keyring);
    void __fastcall ScanKeyringBuf(AnsiString &Keyring);
    void __fastcall GrowTree();
};

//---------------------------------------------------------------------------
extern TPgpTestDlg *PgpTestDlg;
//---------------------------------------------------------------------------
#endif
