#define _WINSOCKAPI_      // Prevent winsock.h from being included
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <sysutils.hpp>
#pragma hdrstop

#include "RemailerDlgs.h"
#include "MixProbWins.h"
#include "MixKeyWins.h"
#include "CpkKeyWins.h"
#include "HttpProxyDlgs.h"
#include "Global.h"
#include "FileMan.h"
#include "UrlsDlg.h"
#include "Mixmaster.h"
#include "Cyberpunk.h"
#include "PgpMail.h"
#include "HelpDlgs.h"
#include "docmsgdlg.h"
#include "smtpdlgs.h"
#include "deldocsdlg.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "HttpProt"
#pragma link "explbtn"
#pragma resource "*.dfm"
TRemailerDlg *RemailerDlg;
//AnsiString httpretval;
const AnsiString ChecksPage = "Error Checks";
//---------------------------------------------------------------------------
bool __fastcall GetRemailerStats(TForm *Owner, bool attended)
{
   RemailerDlg = new TRemailerDlg(Owner);
   CenterDialog(RemailerDlg,Owner);
   bool ok = RemailerDlg->Execute(attended);
   delete RemailerDlg;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall DocumentErrorChecking()
{
   return GetAppIni(StatsErrCheck,"").ToIntDef(1);
}
//---------------------------------------------------------------------------
__fastcall TRemailerDoc::TRemailerDoc()
   : TStringList()
{
   Modified = OpenDoc = false;
}
//---------------------------------------------------------------------------
__fastcall TRemailerDoc::TRemailerDoc(AnsiString Docfile)
   : TStringList()
{
   if (FileExists(Docfile)) LoadFromFile(Docfile);
   Modified = OpenDoc = false;
}
//---------------------------------------------------------------------------
__fastcall TRemailerDlg::TRemailerDlg(TComponent* Owner)
    : TForm(Owner)
{
   if (FileExists(clisttmp)) DeleteFile(s(clisttmp).c_str());
   DocMemo->Clear();
   DocMemo->Font->Name = GetAppIni("FontName","Courier New");
   DocMemo->Font->Size = GetAppIni("FontSize","").ToIntDef(10);
   ErrorCheck->Checked = DocumentErrorChecking();
   TimeOut = GetAppIni(StatsTimeOut,"").ToIntDef(30);

   CenterDialog(this);
   PageControl1->ActivePage = TabSheet1;
   Label1->Caption = "";
   if (!HasPgp())
   {
      CyberpunkGrp->Visible = false;
      MixmasterGrp->Height += 107;
   }
   CancelAnyway = false;
   Cancelled = false;
   Attended = false;

   Timer3->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::Timer3Timer(TObject *Sender)
{
   Timer3->Enabled = false;
   HttpCli1->RcvdStream = NULL;
   LoadHttpInfo();

   Tabs = TabSet->Tabs;
   MixSelfUpdate = false;
   CpkSelfUpdate = false;
   MixGenType2();

   mixkeys = new TMixKeyList();
   mixdups = new TMixKeyList();
   mixnokey = new TStringList();
   mixnokey->Sorted = true;

   cpkkeys = new TCpkKeyList();
   cpkdups = new TCpkKeyList();
   cpknokey = new TStringList();
   cpknokey->Sorted = true;

   TRemailerDoc *log = new TRemailerDoc();
   if (GetLastErrChkLog(log))
   {
      Tabs->AddObject(ChecksPage,NULL);
      TabSet->TabIndex = Tabs->Count-1;
      DocMemo->Text = log->Text;
      DocMemo->Modified = false;
   }
   else delete log;

   MixGenType2();
   CpkGenType1();
}
//---------------------------------------------------------------------------
__fastcall TRemailerDlg::~TRemailerDlg()
{
   for (int i=0; i<Tabs->Count; i++)
      delete dynamic_cast<TRemailerDoc*>(Tabs->Objects[i]);
   delete HttpCli1->RcvdStream;

   delete mixnokey;
   delete mixdups;
   delete mixkeys;

   delete cpknokey;
   delete cpkdups;
   delete cpkkeys;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::WMGetButtonClick(TMessage& Msg)
{
   GetBtnClick();
}
//---------------------------------------------------------------------------
void __fastcall SetCBoxCur(TComboBox *cbox, int listpos)
{
   if (listpos<cbox->Items->Count) cbox->ItemIndex = listpos;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::LoadURLs()
{
   GetAppData(MListCBox->Items,StatsURLs+PS+MListTxt); SetCBoxCur(MListCBox,0);
   GetAppData(MRingCBox->Items,StatsURLs+PS+MRingTxt); SetCBoxCur(MRingCBox,0);
   GetAppData(MTyp2CBox->Items,StatsURLs+PS+MTyp2Txt); SetCBoxCur(MTyp2CBox,0);
   GetAppData(CListCBox->Items,StatsURLs+PS+CListTxt); SetCBoxCur(CListCBox,0);
   GetAppData(CRingCBox->Items,StatsURLs+PS+CRingTxt); SetCBoxCur(CRingCBox,0);
   GetAppURLs();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::SaveErrChkLog(TRemailerDoc *Log)
{
   if (!Log || !Log->Count) return;
   TRemailerDoc *list = new TRemailerDoc();
   GetAppData(list,ErrChkLog);
   int max = GetAppIni(ErrChkLogMax,"").ToIntDef(16);
   while (max && list->Count>=max)
   {
      PutAppData(ErrChkLog+PS+list->Strings[0],NULL);
      list->Delete(0);
   }
   AnsiString logstr = SMTPPOP3logtime()+" "+Log->Strings[Log->Count-1];
   PutAppData(ErrChkLog+PS+logstr,Log);
   delete list;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::GetLastErrChkLog(TStrings *Log)
{
   Log->Clear();
   TStringList *list = new TRemailerDoc();
   GetAppData(list,ErrChkLog);
   if (list->Count) GetAppData(Log,ErrChkLog+PS+list->Strings[list->Count-1]);
   delete list;
   return Log->Count>0;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   switch (ModalResult)
   {
      case mrOk: SaveStatistics(); break;
      case mrCancel:
         if (GoodTabs())
         {
            switch (MsgBoxHwnd(Handle,
               "Your new remailer docs are not saved!\n\nSave them now?",
               "Remailer Documents",MB_YESNOCANCEL))
            {
               case ID_CANCEL:
                  CanClose = false;
                  break;
               case ID_YES:
                  SaveStatistics();
                  break;
            }
         }
   }
   if (!CanClose) return;

   if (CancelAnyway) ModalResult = mrCancel;
   PutAppIni(StatsErrCheck,ErrorCheck->Checked ? "1":"0");
   if (FileExists(clisttmp)) DeleteFile(s(clisttmp).c_str());
   StoreHttpInfo();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::CheckDocumentsExist()
{
   int reply;
   if (!Cancelled && !FileExists(mlisttxt) && MRingBox->Checked && !MListBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        "Your 'mlist.txt' document is missing. Shall I get it while online?",
        "Mixmaster Statistics",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            MListBox->Checked = true;
            break;
      }
   }
   MixGenType2();

   if (!Cancelled && !FileExists(clisttxt) && CRingBox->Checked && !CListBox->Checked)
   {
      reply = MsgBoxHwnd(Handle,
        "  Your 'rlist.txt' document is missing. Shall I get it while online?  ",
        "Cyberpunk Statistics",
         MB_YESNOCANCEL
      );
      switch (reply)
      {
         case IDCANCEL:
            Cancelled = true;
            break;
         case IDYES:
            CListBox->Checked = true;
            break;
      }
   }
   CpkGenType1();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::ClearDocuments()
{
   for (int t=0; t<Tabs->Count; t++)
      delete dynamic_cast<TRemailerDoc*>(Tabs->Objects[t]);
   DocMemo->Clear();
   Tabs->Clear();
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::IsTab(int Index, AnsiString &TabName)
{
   if (Index>=0 && Index<Tabs->Count)
      return Tabs->Strings[Index]==TabName;
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::GetDocsClick(TObject *Sender)
{
   if (!MListBox->Checked && !MRingBox->Checked && !MTyp2Box->Checked &&
       !CListBox->Checked && !CRingBox->Checked)
   {
      MsgBoxHwnd(Handle,"Nothing checked for update!","Document Error",MB_OK);
      return;
   }
   bool cancel=false;
   GetAppURLs(); CheckDocumentsExist();
   if (GoodTabs())
   {
      switch (MsgBoxHwnd(Handle,
         "You have good remailer docs not saved!\n\nSave them now?",
         "Remailer Documents",MB_YESNOCANCEL))
      {
         case ID_YES:
            SaveStatistics();
            break;
         case ID_CANCEL:
            cancel = true;
            break;
      }
   }
   if (cancel) return;
   ClearDocuments();
   cpknokey->Clear();
   cpkkeys->Clear();
   cpkdups->Clear();
   mixnokey->Clear();
   mixkeys->Clear();
   mixdups->Clear();
   GetBtnClick();
//sm(Attended==true?"Y":"N");
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::ResetSelfUpdate()
{
  if (MixSelfUpdate)
  {
     MRingBox->Checked = false;
     MixSelfUpdate = false;
  }
  if (CpkSelfUpdate)
  {
     CRingBox->Checked = false;
     CpkSelfUpdate = false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::GetBtnClick()
{
   if (!MListBox->Checked && !MRingBox->Checked && !MTyp2Box->Checked &&
       !CListBox->Checked && !CRingBox->Checked)
   {
      MsgBoxHwnd(Handle,"Nothing checked for update!","Document Error",MB_OK);
      Cancelled = true;
   }
   if (Cancelled)
   {
      ResetSelfUpdate();
      ResetCheckboxes();
      return;
   }

   if (!Timer1->Enabled) Timer1->Enabled = true;
   if (GetDocs->Enabled && GetDocs->Caption=="Get Docs")
      Panel3->Enabled = false;

   GetDocs->Enabled = false;
   HelpBtn->Enabled = false;
   OkBtn->Enabled = false;

   if (MListBox->Enabled && MListBox->Checked)
      GetStatistics(MListURL,MListBox,MListTxt);
   else
   if (MRingBox->Enabled && MRingBox->Checked)
      GetStatistics(MRingURL,MRingBox,MRingTxt);
   else
   if (MTyp2Box->Enabled && MTyp2Box->Checked)
      GetStatistics(MTyp2URL,MTyp2Box,MTyp2Txt);
   else
   if (CListBox->Enabled && CListBox->Checked)
      GetStatistics(CListURL,CListBox,CListTxt);
   else
   if (CRingBox->Enabled && CRingBox->Checked)
      GetStatistics(CRingURL,CRingBox,CRingTxt);
   else
   {
      ResetCheckboxes(); Label1->Caption = "";
      ProgressBar1->Visible = false; Label1->Caption = "";
      TabSet->TabIndex = Tabs->Count-1;
      if (ErrorCheck->Checked)
      {
         Sleep(200);
         TRemailerDoc *doc;
         Tabs->AddObject(ChecksPage,NULL);
         TabSet->TabIndex = Tabs->Count-1;
         Application->ProcessMessages();
         bool ok1=true,ok2=true,ok3=true,ok4=true;
         for (int i=0; i<Tabs->Count; i++)
         {
            if (Cancelled) break;
            if ((doc=GetDoc(i))!=NULL)
            {
               if (IsTab(i,MListTxt)) ok1=MixListOk(doc); else
               if (IsTab(i,MRingTxt)) ok2=MixRingOk(doc); else
               if (IsTab(i,CListTxt)) ok3=CpkListOk(doc); else
               if (IsTab(i,CRingTxt)) ok4=CpkRingOk(doc);
            }
         }
         if (!ok1 || !ok2 || !ok3 || !ok4 || Cancelled)
         {
            if (!Attended) Display("Operation cancelled");
            Display("Done!");
            CancelAnyway = true;
            Cancelled = true;
            Attended = true;
            GetDocs->Enabled = true;
            HelpBtn->Enabled = true;
            OkBtn->Enabled = true;
            ResetSelfUpdate();
            GetBtnClick();
            return;
         }
         /*if (Cancelled)
         {
            if (!Attended) Display("Operation cancelled");
            Display("Done!");
            Attended = true;
         }*/
         AppProcessMessages();
         Sleep(100);
      }

      ResetSelfUpdate();
      ActiveControl = DocMemo;
      ProgressBar1->Position = 100;
      AppProcessMessages(); Sleep(100);
      Panel3->Enabled = true;
      UrlsBtn->Enabled = true;
      ProxyBtn->Enabled = true;
      GetDocs->Enabled = true;
      OkBtn->Enabled = true;
      HelpBtn->Enabled = true;
      Label1->Caption = "";
      Cancelled = false;

      if (Attended) MyBeep(MB_OK); // if attended, just this line
      else
      {
         ModalResult = !Cancelled || (Cancelled && Tabs->Count>1) ? mrOk:mrCancel;
         ProgressBar1->Visible = false;
         CancelBtn->Enabled = false;
         GetDocs->Enabled = false;
         OkBtn->Enabled = false;
         HelpBtn->Enabled = false;
         AppProcessMessages();
         Sleep(100);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall ClearTypeList(TRemailerDoc *TypeList)
{  // clears type1.list or type2.list of all but disables (#)
   int t=0; while (t<TypeList->Count)
   {
      if (TypeList->Strings[t].Pos("#")!=1) TypeList->Delete(t);
      else t++;
   }
}
//---------------------------------------------------------------------------
TRemailerDoc* __fastcall TRemailerDlg::GetDocument(AnsiString &DocName)
{
   TRemailerDoc *doc;
   AnsiString md=MixDir();
   // if the doc was not downloaded get it from disk
   int Index=Tabs->IndexOf(DocName);
   if (Index>=0) doc = GetDoc(Index);
   else
   {
      doc = new TRemailerDoc();
      if (FileExists(MixDir()+DocName)) doc->LoadFromFile(MixDir()+DocName);
      Tabs->AddObject(DocName,NULL);
      TabSet->TabIndex = Tabs->Count-1;
      Application->ProcessMessages(); Sleep(200);
      SetDoc(DocName,doc);
   }
   // special handling cpunk keyring
   if (DocName==CRingTxt && HasPgp()) CpkBlockToKeysFull(doc);
   // end special
   SetDocMemo(doc);
   return doc;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CorruptDoc(TRemailerDoc *Doc)
{
   return Doc && Doc->Text.Trim().Pos(CorruptReport)==1;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::SaveStatistics()
{
   if (!GoodTabs()) return false;

   AnsiString TxtFile;
   TRemailerDoc *TxtList;
   int i,pos,bakcopies=STATSBAKCOPIES;
   // copy current docmemo to tab stringlist to get possible edits
   SetTab(TabSet->TabIndex);
   // process tabs
   for (i=0; i<Tabs->Count; i++)
   {
      TxtList = GetDoc(i);
      TxtFile = Tabs->Strings[i];
      if (TxtList==NULL || TxtList->Text.IsEmpty() || TxtFile=="Error") continue;
      if (TxtFile==ChecksPage) { SaveErrChkLog(TxtList); continue; }
      if (TxtFile==MTyp2Txt || TxtFile==CTyp1Txt) continue;
      if (TxtFile==MListTxt || TxtFile==CListTxt)
      {
         SaveToFileBak(TxtList,MixDir()+TxtFile,bakcopies);
         continue;
      }
      if (TxtFile==MRingTxt)
      {
         TMixKeyList *keys = new TMixKeyList(mringtxt);
         if (mixkeys->Count)
         {
            for (int i=0; i<mixdups->Count; i++)
            {
               if ((pos=mixkeys->IndexOf(mixdups->Strings[i]))>=0)
                  mixkeys->Delete(pos);
            }
            if (!MixKeyWin) MixKeyWin = new TMixKeyWin(AppMainForm,mringtxt,mtyp2txt);
            MixKeyWin->WindowState = wsNormal;
            AppProcessMessages();
            MixKeyWin->BringToFront();
            MixKeyWin->AddKeysImport(mixkeys,false);
            AnsiString tmp = FormatDateTime("yyyy-mm-dd",Date());
         }
         if (mixdups->Count)
         {
            if (!MixProbWin) MixProbWin = new TMixProbWin(AppMainForm,false);
            else MixProbWin->WindowState = wsNormal;
            AppProcessMessages();
            MixProbWin->BringToFront();
            MixProbWin->AddKeysImport(mixdups,false);
         }
         PutAppIni(MixKeyUpdate,FormatDateTime("yyyy-mm-dd",Date()));
         delete keys;
         continue;
      }
      if (TxtFile==CRingTxt)
      {
         TCpkKeyList *keys = new TCpkKeyList(cringtxt);
         if (cpkkeys->Count)
         {
            for (int i=0; i<cpkdups->Count; i++)
            {
               if ((pos=cpkkeys->IndexOf(cpkdups->Strings[i]))>=0)
                  cpkkeys->Delete(pos);
            }
            if (!CpkKeyWin) CpkKeyWin = new TCpkKeyWin(AppMainForm,cringtxt,ctyp1txt,clisttxt);
            else CpkKeyWin->WindowState = wsNormal;
            AppProcessMessages();
            CpkKeyWin->BringToFront();
            CpkKeyWin->AddKeysImport((TCpkKeyList*)cpkkeys);
         }
         if (cpkdups->Count)
         {
            if (!CpkKeyWin) CpkKeyWin = new TCpkKeyWin(AppMainForm,cringtxt,ctyp1txt,clisttxt);
            else CpkKeyWin->WindowState = wsNormal;
            AppProcessMessages();
            CpkKeyWin->BringToFront();
            CpkKeyWin->AddDupsImport((TCpkKeyList*)cpkdups);
         }
         PutAppIni(CpkKeyUpdate,FormatDateTime("yyyy-mm-dd",Date()));
         delete keys;
         continue;
      }
   }
   return true;
}
/*//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::SaveStatistics()
{
   if (!GoodTabs()) return false;

   AnsiString TxtFile;
   TRemailerDoc *TxtList;
   int i,pos,bakcopies=STATSBAKCOPIES;
   // copy current docmemo to tab stringlist to get possible edits
   SetTab(TabSet->TabIndex);
   // process tabs
   for (i=0; i<Tabs->Count; i++)
   {
      TxtList = GetDoc(i);
      TxtFile = Tabs->Strings[i];
      if (TxtList==NULL || TxtList->Text.IsEmpty() || TxtFile=="Error") continue;
      if (TxtFile==ChecksPage) { SaveErrChkLog(TxtList); continue; }
      if (TxtFile==MRingTxt)
      {
         TMixKeyList *keys = new TMixKeyList(mringtxt);
         if (mixkeys->Count)
         {
            for (int i=0; i<mixdups->Count; i++)
            {
               if ((pos=mixkeys->IndexOf(mixdups->Strings[i]))>=0)
                  mixkeys->Delete(pos);
            }
            keys->AddKeys(mixkeys);
            keys->SaveToFileBak(mringtxt,bakcopies);
            PutAppIni(MixKeyUpdate,FormatDateTime("yyyy-mm-dd",Date()));
         }

         if (mixdups->Count)
         {
            if (!MixProbWin) MixProbWin = new TMixProbWin(AppMainForm,false);
            MixProbWin->keylist->AddKeys(mixdups);
            MixProbWin->keylist->GenTreeView(MixProbWin->TreeView,MixProbWin->typlist,MixProbWin->keynode);
            MixProbWin->keylist->SaveToFile(mprobtxt);
            MixProbWin->BringToFront();
            continue;
         }
         delete keys;
      }
      if (TxtFile==CRingTxt)
      {
         TCpkKeyList *keys = new TCpkKeyList(cringtxt);
         if (cpkkeys->Count)
         {
            for (int i=0; i<cpkdups->Count; i++)
            {
               int pos = cpkkeys->IndexOf(cpkdups->Strings[i]);
               if (pos>=0) cpkkeys->Delete(pos);
            }
            keys->AddKeys(cpkkeys);
            keys->SaveToFileBak(cringtxt,bakcopies);
         }
         if (cpkdups->Count)
         {
            if (CpkProbWin)
            {
               CpkProbWin->keylist->AddKeys(cpkdups);
            }
            else
            {
               keys->LoadFromFile(cprobtxt);
               keys->AddKeys(cpkdups);
               keys->SaveToFile(cprobtxt);
               CpkProbWin = new TCpkProbWin(AppMainForm,false);
            }
         }
         delete keys;
         continue;
      }
      // special for pubring.asc, make single keyblock
      //if (ErrorCheck->Checked && HasPgp() && TxtFile==CRingTxt)
      //   CpkKeysToBlock(TxtList);
      //==Save Statistics======================================
      SaveToFileBak(TxtList,MixDir()+TxtFile,bakcopies);
      //=======================================================
   }
   return true;
}
*/
//---------------------------------------------------------------------------
int __fastcall TRemailerDlg::GoodTabs()
{
   int valtabs=0;
   for (int i=0; i<Tabs->Count; i++)
   {
      TRemailerDoc *doc = GetDoc(i);
      if (Tabs->Strings[i]=="Error" || Tabs->Strings[i]==ChecksPage) continue;
      if (doc && doc->Count && doc->Text.Pos(CorruptReport)==1) continue;
    //if (doc->Modified)
      valtabs++;
   }
   return valtabs;
}
//---------------------------------------------------------------------------
TRemailerDoc* __fastcall TRemailerDlg::TabDoc(int Index)
{
   // returns doc from tab or null if corrupt
   if (Index<0 || Index>=Tabs->Count) return NULL;
   TRemailerDoc *Doc = GetDoc(Index);
   if (Doc && Doc->Count && Doc->Text.Pos(CorruptReport)==1)
      Doc = NULL;
   return Doc;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::SetTab(int Index)
{
   if (Index>=0 && Index<Tabs->Count) // make sure tabdoc = docmemo
   {
      TRemailerDoc *doc = GetDoc(Index);
      if (!doc)
      {
         doc = new TRemailerDoc();
         Tabs->Objects[Index] = doc;
      }
      doc->Text = DocMemo->Lines->Text;
      DocMemo->Modified = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::FormShow(TObject *Sender)
{
   ActiveControl = Panel2;
   if (!Attended)
   {
      //LoadURLs();
      PostMessage(Handle,WM_GETBUTTONCLICK,0,NULL);
      //Timer2->Enabled = true;
      //return;
   }
   LoadURLs();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::Display(AnsiString &text)
{
   ActiveControl = DocMemo;
   DocMemo->Lines->Add(text);
   Application->ProcessMessages();
   Sleep(10);
}
/*//---------------------------------------------------------------------------
bool __fastcall InTypeX(AnsiString &remailer, TStrings *list)
{
   bool ok = false; if (!list) return ok;
   for (int i=0; i<list->Count; i++)
   {
      if (list->Strings[i]==remailer || list->Strings[i]=="#"+remailer)
      {
         ok = true;
         break;
      }
   }
   return ok;
}*/
//---------------------------------------------------------------------------
AnsiString KeyRingCnt(int val)
{
   AnsiString v=AnsiString(val);
   if (v.Length()<2) v = " "+v; return v;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CpkListOk(TRemailerDoc *Doc)
{
   AnsiString line,statsheader =
      s("remailer  email address                        history  latency  uptime\r\n")+
      s("-----------------------------------------------------------------------\r\n");
   int pos;
   for(int i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i];
      while ((pos=line.Pos("&lt;"))>0 || (pos=line.Pos("&gt;"))>0)
         line.Delete(pos,4);
      if (line!=Doc->Strings[i]) Doc->Strings[i] = line;
   }
   if (Doc->Text.Pos(statsheader)==0)
   {
      AppProcessMessages();
      Doc->Insert(0,CorruptReport);
      Display("rlist.txt...CORRUPT");
      Display(" The new 'rlist.txt' document appears corrupt. I'm");
      Display(" unable to locate these statistics column headings.");
      Display(" \"remailer  email address        history  latency  uptime\"");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it. See Help");
      AppProcessMessages(); Sleep(500);
      return false;
   }
   int c=0;
   for (int i=0; i<Doc->Count; i++)
      if (CpkListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      AppProcessMessages();
      Doc->Insert(0,CorruptReport);
      Display("rlist.txt...CORRUPT");
      Display(" The new 'rlist.txt' document appears corrupt. I've");
      Display(" located the stats column headers, but found no actual");
      Display(" stats lines at all. The document has been marked so");
      Display(" you can't accidentally save it. See Help");
      AppProcessMessages(); Sleep(500);
      return false;
   }
   if (cpknokey->Count)
   {
      AnsiString rems,rem,theS = cpknokey->Count>1 ? "S":"";
      Display("rlist.txt..."+s(cpknokey->Count)+" NEW REMAILER"+theS+
         " Auto-updating pubring.asc");
      int i=0; while (i<cpknokey->Count)
      {
         rems = "";
         while (rems.Length()<60 && i<cpknokey->Count)
         {
            rem = cpknokey->Strings[i++];
            rems += rem+s("             ").SubString(1,12-rem.Length());
         }
         Display("  "+rems);
      }
   }
   Display("rlist.txt...OK");
   Doc->SaveToFile(clisttmp);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CpkRingOk(TRemailerDoc *Doc)
{
   int begs=0,ends=0;
   AnsiString desc,line,newshort;
   for (int i=0; i<Doc->Count; i++)
   {
      line=Doc->Strings[i].Trim();
      if (line==BeginPgpPubKeyBlock) begs++; else
      if (line==EndPgpPubKeyBlock) ends++;
   }
   if (begs==0 || begs!=ends)
   {
      AppProcessMessages();
      Doc->Insert(0,CorruptReport);
      Display("pubring.asc...CORRUPT");
      Display(" The new 'pubring.asc' document appears corrupt. The");
      Display(" values below should BOTH be greater than 0 AND equal.");
      Display(" "+s(begs)+" "+BeginPgpPubKeyBlock+" lines");
      Display(" "+s(ends)+" "+EndPgpPubKeyBlock+" lines");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it."),
      AppProcessMessages(); Sleep(500);
      return false;
   }

   if (!HasPgp()) return true;

   // doc is ok, check for new keys
   TStringList *type1 = new TStringList(); type1->Sorted = true;
   if (FileExists(ctyp1txt)) type1->LoadFromFile(ctyp1txt);
   TCpkKeyList *curdb = new TCpkKeyList(cringtxt);
   //TCpkKeyList *prodb = new TCpkKeyList(cprobtxt);
   TCpkKeyList *newdb = new TCpkKeyList(Doc);
   for (int i=0; i<newdb->Count; i++)
   {
      desc = newdb->CrtDesc(i);
      if (curdb->IndexOf(desc)<0) // && prodb->IndexOf(desc)<0 && !InType1(desc,type1))
         cpkkeys->ImportAscii(newdb->ExportAscii(i));
   }
   delete newdb;
   // any duplicates...
   for (int m=0; m<cpkkeys->Count; m++)
   {
      newshort = GetToken(0,cpkkeys->KeyDesc(m)," ").LowerCase();
      for (int c=0; c<curdb->Count; c++)
      {
         if (newshort==GetToken(0,curdb->KeyDesc(c)," ").LowerCase())
         {
            cpkdups->ImportAscii(cpkkeys->ExportAscii(m));
            break;
         }
      }
   }
   //delete prodb;
   delete curdb;
   delete type1;

   type1=GetDoc(CTyp1Txt);
   CpkGenType1(type1,Doc);

   if (cpkkeys->Count)
   {
      AnsiString theS = cpkkeys->Count>1 ? "S":"";
      Display("pubring.asc..."+s(cpkkeys->Count)+" NEW KEY"+theS);
      for (int i=0; i<cpkkeys->Count; i++) Display("  "+cpkkeys->CrtDesc(i));
   }
   if (cpkdups->Count)
   {
      AnsiString theS = cpkdups->Count>1 ? "S":"";
      Display("pubring.asc..."+s(cpkdups->Count)+" DUPLICATE KEY"+theS);
      for (int i=0; i<cpkdups->Count; i++) Display("  "+cpkdups->CrtDesc(i));
   }

   Display("pubring.asc...OK");
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::MixListOk(TRemailerDoc *Doc)
{
   AnsiString statsheader =
      s("mixmaster           history  latency  uptime\r\n")+
      s("--------------------------------------------\r\n");
   if (Doc->Text.Pos(statsheader)==0)
   {
      Doc->Insert(0,CorruptReport);
      Display("mlist.txt...CORRUPT");
      Display(" The new 'mlist.txt' document appears corrupt. I'm");
      Display(" unable to locate these statistics columns headings.");
      Display(" \"mixmaster           history  latency  uptime\"");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it. See Help");
      AppProcessMessages(); Sleep(500);
      return false;
   }
   int c=0; for (int i=0; i<Doc->Count; i++)
      if (MixListLineOk(Doc->Strings[i])) c++;
   if (!c)
   {
      Doc->Insert(0,CorruptReport);
      Display("mlist.txt...CORRUPT");
      Display(" The new 'mlist.txt' document appears corrupt. I've");
      Display(" located the stats column headers, but found no actual");
      Display(" stats lines at all. The document has been marked so");
      Display(" you can't accidentally save it.");
      AppProcessMessages(); Sleep(500);
      return false;
   }
   if (mixnokey->Count)
   {
      AnsiString rems,rem,theS = mixnokey->Count>1 ? "S":"";
      Display("mlist.txt..."+s(mixnokey->Count)+" NEW REMAILER"+theS+
         " Auto-updating pubring.mix");
      int i=0; while (i<mixnokey->Count)
      {
         rems = "";
         while (rems.Length()<60 && i<mixnokey->Count)
         {
            rem = mixnokey->Strings[i++];
            rems += rem+s("             ").SubString(1,12-rem.Length());
         }
         Display("  "+rems);
      }
   }
   Display("mlist.txt...OK");
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::MixRingOk(TRemailerDoc *Doc)
{
   int descrips=0,begs=0,ends=0;
   AnsiString desc,line,newshort,s;//descrip,s;
   for (int i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i];
      if (MixRingLineOk(line)) descrips++; else
      if (line==BeginMixKey) begs++; else
      if (line==EndMixKey) ends++;
   }

   if (!descrips || descrips!=begs || begs!=ends)
   {
      AppProcessMessages();
      Doc->Insert(0,CorruptReport);
      Display("pubring.mix...CORRUPT");
      Display(" The new 'pubring.mix' document appears corrupt. The");
      Display(" values below should be greater than 0 AND equal.");
      Display("  "+KeyRingCnt(descrips)+"  Mixmaster key description lines");
      Display("  "+KeyRingCnt(begs)+"  "+BeginMixKey+" lines");
      Display("  "+KeyRingCnt(ends)+"  "+EndMixKey+" lines");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it.");
      AppProcessMessages(); Sleep(500);
      return false;
   }

   // doc is ok, check for new keys
   TStringList *type2 = new TStringList(); type2->Sorted = true;
   if (!FileExists(mringtxt) && FileExists(mtyp2txt)) DeleteFile(s(mtyp2txt).c_str());
   if ( FileExists(mtyp2txt)) type2->LoadFromFile(mtyp2txt);

   TMixKeyList *curdb = new TMixKeyList();
   if (MixKeyWin) curdb->AddKeys(MixKeyWin->keylist);
   else if (FileExists(mringtxt)) curdb->LoadFromFile(mringtxt);

   TMixKeyList *prodb = new TMixKeyList(mprobtxt);
   if (MixProbWin) prodb->AddKeys(MixProbWin->keylist);
   else if (FileExists(mprobtxt)) prodb->LoadFromFile(mprobtxt);

   curdb->AddKeys(prodb);
   TMixKeyList *newdb = new TMixKeyList(Doc);
   for (int i=0; i<newdb->Count; i++)
   {
      desc = newdb->CrtDesc(i);
      if (curdb->IndexOf(desc)<0 && prodb->IndexOf(desc)<0)
         mixkeys->ImportAscii(newdb->ExportAscii(i));
   }
   delete newdb;
   delete prodb;

   // duplicates?...
   for (int m=0; m<mixkeys->Count; m++)
   {
      newshort = GetToken(0,mixkeys->KeyDesc(m)," ").LowerCase();
      for (int c=0; c<curdb->Count; c++)
      {
         if (newshort==GetToken(0,curdb->KeyDesc(c)," ").LowerCase())
         {
            mixdups->ImportAscii(mixkeys->ExportAscii(m));
            break;
         }
      }
   }
   delete curdb;
   delete type2;

   type2=GetDoc(MTyp2Txt);
   MixGenType2(type2,Doc);

   if (mixkeys->Count)
   {
      AnsiString theS = mixkeys->Count>1 ? "S":"";
      Display("pubring.mix..."+s(mixkeys->Count)+" NEW KEY"+theS);
      for (int i=0; i<mixkeys->Count; i++) Display("  "+mixkeys->CrtDesc(i));
   }
   if (mixdups->Count)
   {
      AnsiString theS = mixdups->Count>1 ? "S":"";
      Display("pubring.mix..."+s(mixdups->Count)+" DUPLICATE KEY"+theS);
      for (int i=0; i<mixdups->Count; i++) Display("  "+mixdups->CrtDesc(i));
   }

   Display("pubring.mix...OK");
   return true;
}
/*//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::MixRingOk(TRemailerDoc *Doc)
{
   int descrips=0,begs=0,ends=0;
   AnsiString desc,line,newshort,s;//descrip,s;
   for (int i=0; i<Doc->Count; i++)
   {
      line = Doc->Strings[i];
      if (MixRingLineOk(line)) descrips++; else
      if (line==BeginMixKey) begs++; else
      if (line==EndMixKey) ends++;
   }

   if (!descrips || descrips!=begs || begs!=ends)
   {
      AppProcessMessages();
      Doc->Insert(0,CorruptReport);
      Display("pubring.mix...CORRUPT");
      Display(" The new 'pubring.mix' document appears corrupt. The");
      Display(" values below should be greater than 0 AND equal.");
      Display("  "+KeyRingCnt(descrips)+"  Mixmaster key description lines");
      Display("  "+KeyRingCnt(begs)+"  "+BeginMixKey+" lines");
      Display("  "+KeyRingCnt(ends)+"  "+EndMixKey+" lines");
      Display(" The document has been marked so you can't accidentally");
      Display(" save it.");
      AppProcessMessages(); Sleep(500);
      return false;
   }

   // doc is ok, check for new keys
   TStringList *type2 = new TStringList(); type2->Sorted = true;
   if (FileExists(mtyp2txt)) type2->LoadFromFile(mtyp2txt);
   TMixKeyList *curdb = new TMixKeyList(mringtxt);
   TMixKeyList *prodb = new TMixKeyList(mprobtxt);
   TMixKeyList *newdb = new TMixKeyList(Doc);
   for (int i=0; i<newdb->Count; i++)
   {
      desc = newdb->CrtDesc(i);
      if (curdb->IndexOf(desc)<0 && prodb->IndexOf(desc)<0 && !InType2(desc,type2))
         mixkeys->ImportAscii(newdb->ExportAscii(i));
   }
   delete newdb;
   // any duplicates...
   for (int m=0; m<mixkeys->Count; m++)
   {
      newshort = GetToken(0,mixkeys->KeyDesc(m)," ").LowerCase();
      for (int c=0; c<curdb->Count; c++)
      {
         if (newshort==GetToken(0,curdb->KeyDesc(c)," ").LowerCase())
         {
            mixdups->ImportAscii(mixkeys->ExportAscii(m));
            break;
         }
      }
   }
   delete prodb;
   delete curdb;
   delete type2;

   type2=GetDoc(MTyp2Txt);
   MixGenType2(type2,Doc);

   if (mixkeys->Count)
   {
      AnsiString theS = mixkeys->Count>1 ? "S":"";
      Display("pubring.mix..."+s(mixkeys->Count)+" NEW KEY"+theS);
      for (int i=0; i<mixkeys->Count; i++)
         Display("  "+mixkeys->CrtDesc(i));
   }
   if (mixdups->Count)
   {
      AnsiString theS = mixdups->Count>1 ? "S":"";
      Display("pubring.mix..."+s(mixdups->Count)+" DUPLICATE KEY"+theS);
      for (int i=0; i<mixdups->Count; i++)
         Display("  "+mixdups->CrtDesc(i));
   }

   Display("pubring.mix...OK");
   return true;
}*/
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::GetStatistics(AnsiString &forURL, TCheckBox *Box,
   AnsiString &Doc)
{
   CurDoc = Doc;
   CurBox = Box;
   Cap = forURL;//+"...";
   Label1->Caption = Cap;
   //CancelBtn->Caption = "Cancel";
   HttpCli1->URL = forURL;
   HttpCli1->Proxy = ProxyHost;
   HttpCli1->ProxyPort = ProxyPort;
   HttpCli1->ProxyUsername = ProxyUser;
   HttpCli1->ProxyPassword = ProxyPswd;
   HttpCli1->ModifiedSince = 0;
   ProgressBar1->Position = 0;
   ProgressBar1->Visible = true;

   BytesReceived = 0;
   TimeOutTimer->Enabled = true;
   CurTime = 0;

   try {
       HttpCli1->HeadASync();
   } __except (TRUE) {
       //GetDocs->Enabled = true;
       //TabSheet1->Enabled = true;
       Panel3->Enabled = true;

       DocMemo->Clear();
       DocMemo->Lines->Add("Head Failed !");
       DocMemo->Lines->Add("Status = " + IntToStr(HttpCli1->StatusCode));
       DocMemo->Lines->Add("Reason = " + HttpCli1->ReasonPhrase);
       PageControl1->ActivePage = TabSheet3;
       ProgressBar1->Visible = false;
       TimeOutTimer->Enabled = false;

       return false;
   }
   return !Cancelled;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::LoadHttpInfo()
{
   TRemailerDoc *http = new TRemailerDoc();
   GetAppData(http,HttpInfo);
   MListBox->Checked = http->Values["MListChkd"] == "1";
   MRingBox->Checked = http->Values["MRingChkd"] == "1";
   MTyp2Box->Checked = http->Values["MTyp2Chkd"] == "1";
   CListBox->Checked = http->Values["CListChkd"] == "1";
   CRingBox->Checked = http->Values["CRingChkd"] == "1";
   ProxyHost = http->Values["ProxyHost"];
   ProxyPort = http->Values["ProxyPort"];
   ProxyPswd = http->Values["ProxyPswd"];
   ProxyUser = http->Values["ProxyUser"];
   Http = http->Text; // keep for later compare to see if modified
   delete http;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::StoreHttpInfo()
{
   TRemailerDoc *http = new TRemailerDoc();
   GetAppData(http,HttpInfo);
   http->Values["MListChkd"] = MListBox->Checked?"1":"0";
   http->Values["MRingChkd"] = MRingBox->Checked?"1":"0";
   http->Values["MTyp2Chkd"] = MTyp2Box->Checked?"1":"0";
   http->Values["CListChkd"] = CListBox->Checked?"1":"0";
   http->Values["CRingChkd"] = CRingBox->Checked?"1":"0";
   if (Http!=http->Text) // test for modified
      PutAppData(HttpInfo,http);
   delete http;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::Execute(bool attended)
{
   Attended = attended; ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::ResetCheckboxes()
{
   Timer1->Enabled = false;

   if (MListBox->Checked) MListBox->Enabled = true;
   if (MRingBox->Checked) MRingBox->Enabled = true;
   if (MTyp2Box->Checked) MTyp2Box->Enabled = true;
   if (CListBox->Checked) CListBox->Enabled = true;
   if (CRingBox->Checked) CRingBox->Enabled = true;

   //TabSheet1->Enabled = true;
   Panel3->Enabled = true;
   Cancelled = false;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::HttpCli1DocBegin(TObject *Sender)
{
   BytesReceived = 0;
   ProgressBar1->Position = 0;
   if (HttpCli1->RcvdStream) delete HttpCli1->RcvdStream;
   HttpCli1->RcvdStream = new TMemoryStream();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len)
{
   if (BytesTotal>0)
   {
      BytesReceived += Len;
      ProgressBar1->Position = (BytesReceived/BytesTotal)*100;
      if (BytesReceived==BytesTotal) Sleep(200);
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::HttpCli1DocEnd(TObject *Sender)
{
   ProgressBar1->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::SetDoc(AnsiString DocName, TRemailerDoc *Doc)
{
   int Index=Tabs->IndexOf(DocName);
   if (Index>=0 && Index<Tabs->Count)
   {
      TRemailerDoc *del=GetDoc(Index);
      if (del) delete del;
      Tabs->Objects[Index] = Doc;
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::SetDoc(int Index, TRemailerDoc *Doc)
{
   if (Index>=0 && Index<Tabs->Count)
   {
      TRemailerDoc *del=GetDoc(Index);
      if (del) delete del;
      Tabs->Objects[Index] = Doc;
   }
}
//---------------------------------------------------------------------------
TRemailerDoc* __fastcall TRemailerDlg::GetDoc(AnsiString DocName)
{
   int Index=Tabs->IndexOf(DocName);
   if (Index<0 || Index>=Tabs->Count) return NULL;
   return dynamic_cast<TRemailerDoc*>(Tabs->Objects[Index]);
}
//---------------------------------------------------------------------------
TRemailerDoc* __fastcall TRemailerDlg::GetDoc(int Index)
{
   if (Index<0 || Index>=Tabs->Count) return NULL;
   return dynamic_cast<TRemailerDoc*>(Tabs->Objects[Index]);
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::MixKeysTooOld()
{
   AnsiString now,last=GetAppIni(MixKeyUpdate,"0000-00-00");
   now = FormatDateTime("yyyy-mm-dd",Date());
//sm(last+" -- "+now);
   return last!=now;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::MixListNewRemailer(TRemailerDoc *mixlist)
{
   AnsiString mline,mshort,tshort;
   TRemailerDoc *type2 = new TRemailerDoc(mtyp2txt);
   TRemailerDoc *mring = new TRemailerDoc(mringtxt);
   MixGenType2(type2,mring);
   mixnokey->Clear();
   for (int m=0; m<mixlist->Count; m++)
   {
      mline = mixlist->Strings[m];
      if (!MixListLineOk(mline)) continue;

      bool found=false;
      mshort = GetToken(0,mline," ").LowerCase();
      for (int t=0; t<type2->Count; t++)
      {  // cannot use InType2 -- working with short names only
         tshort = GetToken(0,type2->Strings[t]," ");
         if (mshort==tshort || "#"+mshort==tshort)
         {
            found = true;
            break;
         }
      }
      if (!found) mixnokey->Add(mshort);
   }
   delete type2;
   delete mring;
   return mixnokey->Count>0;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CpkKeysTooOld()
{
   AnsiString now,last=GetAppIni(CpkKeyUpdate,"0000-00-00");
   now = FormatDateTime("yyyy-mm-dd",Date());
   return now<=last;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerDlg::CpkListNewRemailer(TRemailerDoc *cpklist)
{
   AnsiString cline,cshort,tshort;
   TRemailerDoc *type1 = new TRemailerDoc(ctyp1txt);
   TRemailerDoc *cring = new TRemailerDoc(cringtxt);
   CpkGenType1(type1,cring);
   cpknokey->Clear();

   for (int c=0; c<cpklist->Count; c++)
   {
      cline = cpklist->Strings[c];
      if (!CpkListLineOk(cline)) continue;

      bool found=false;
      cshort = GetToken(0,cline," ").LowerCase();
      for (int t=0; t<type1->Count; t++)
      {  // cannot use InType1 -- working with short names only
         tshort = GetToken(0,type1->Strings[t]," ");
         if (cshort==tshort || "#"+cshort==tshort)
         {
            found = true;
            break;
         }
      }
      if (!found) mixnokey->Add(cshort);
   }
   delete type1;
   delete cring;
   return cpknokey->Count>0;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::HttpCli1RequestDone(TObject *Sender,
	THttpRequest RqType, WORD Error)
{
   int pos;
   TRemailerDoc *list;
   AnsiString s,TxtFile;
   if (Error)
   {
      //GetBtn->Caption = "Done";
      PageControl1->ActivePage = TabSheet3;
      TRemailerDoc *tmp = new TRemailerDoc();
      tmp->Add("HTTP Error = "+AnsiString(Error));
      tmp->Add("HTTP Reason = "+HttpCli1->ReasonPhrase);
      TabSet->Tabs->AddObject("Error",tmp);
      TabSet->TabIndex = TabSet->Tabs->Count-1;
      DocMemo->Lines->Text = tmp->Text;
      UrlsBtn->Enabled = true;
      ProxyBtn->Enabled = true;
      TimeOutTimer->Enabled = false;
      return;
   }
   switch (RqType)
   {
      case httpHEAD:
      {
         //sm(HttpCli1->RcvdHeader->Text);
         for (int i=0; i<HttpCli1->RcvdHeader->Count; i++)
         {
            s = HttpCli1->RcvdHeader->Strings[i];
            if (s.Pos("Content-Length: ")==1)
               BytesTotal = s.SubString(17,16).ToIntDef(0);
         }
         HttpCli1->GetASync();
         break;
      }
      case httpGET:
      {
         TimeOutTimer->Enabled = false;
         list = new TRemailerDoc();
         HttpCli1->RcvdStream->Seek(0,soFromBeginning);
         list->LoadFromStream(HttpCli1->RcvdStream);
         Tabs->AddObject(CurDoc,NULL);
         TabSet->TabIndex = Tabs->Count-1;
         Label1->Caption = "";
         SetDoc(CurDoc,list);
         AppProcessMessages();

         // handle html
         AnsiString doc = list->Text.UpperCase();
         if (doc.Pos("<HTML>") && doc.Pos("<PRE>") && doc.Pos("</PRE>"))
         {
            while (list->Count && list->Strings[0].UpperCase().Trim()!="<PRE>")
               list->Delete(0); if (list->Count) list->Delete(0);
            while (list->Count && list->Strings[list->Count-1].UpperCase().Trim()!="</PRE>")
               list->Delete(list->Count-1);
            if (list->Count) list->Delete(list->Count-1);
         }
         // get rid of stupid banner  << these may make a bogus report empyt
         if (CurDoc==CListTxt &&
            (pos=list->Text.Pos("$remailer{"))>0 && list->Text.Pos("Last update: ")>pos)
         {
            // dump the banner--bring the caps portion of list to top
            while (list->Count && list->Strings[0].Pos("$remailer{")!=1)
               list->Delete(0);
            // remove all trailing null
            while (list->Count && list->Strings[list->Count-1].IsEmpty())
               list->Delete(list->Count-1);
            // add 1 trailing null
            list->Add("");
            // move all lines above 'Last update: ' to bottom
            if (list->Count && list->Strings[0].Pos("$remailer{")==1)
            while (list->Strings[0].Pos("Last update: ")!=1)
            {
               list->Add(list->Strings[0]);
               list->Delete(0);
            }
            // remove double skipped lines--leave 1 skipped line
            s = list->Text;
            while ((pos=s.Pos("\r\n\r\n\r\n"))>0) s.Delete(pos,2);
            list->Text = s;
         }
         // get rid of stupid remailer banner
         if (CurDoc==MListTxt && list->Text.Pos("Last update: "))
            while (list->Count && !list->Strings[0].Pos("Last update: "))
               list->Delete(0);
         // set document
         SetDocMemo(list,false);
         AppProcessMessages(); Sleep(500);
         CurBox->Enabled = false;
         AppProcessMessages();

         // auto select keyring for update
         if (CurDoc==MListTxt && !MRingBox->Checked && HasMix() &&
            (MixListNewRemailer(list) || MixKeysTooOld()))
         {
            MRingBox->Checked = true;
            MixSelfUpdate = true;
         }
         if (CurDoc==CListTxt && !CRingBox->Checked && HasPgp() &&
            (CpkListNewRemailer(list) || CpkKeysTooOld()))
         {
            CRingBox->Checked = true;
            CpkSelfUpdate = true;
         }
         if (CurDoc==MRingTxt && ErrorCheck->Checked && HasMix())
         {
            GetDocument(MTyp2Txt);
         }
         if (CurDoc==CRingTxt && ErrorCheck->Checked && HasPgp())
         {
            CpkBlockToKeysFull(list);
            GetDocument(CTyp1Txt);
         }

         if (PageControl1->ActivePage!=TabSheet3)
             PageControl1->ActivePage =TabSheet3;

         GetBtnClick();
         delete HttpCli1->RcvdStream; HttpCli1->RcvdStream = NULL;
         break;
      }
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TRemailerDlg::GetDefaultURL(AnsiString &DocName)
{
   if (DocName==MListTxt) return MListCBox->Text;
   if (DocName==MRingTxt) return MRingCBox->Text;
   if (DocName==MTyp2Txt) return MTyp2CBox->Text;
   if (DocName==CListTxt) return CListCBox->Text;
   if (DocName==CRingTxt) return CRingCBox->Text;
   return "";
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::GetAppURLs()
{
   if ((MListURL = GetDefaultURL(MListTxt))=="") {
      MListBox->Checked=false; MListBox->Enabled=false;
   } else MListBox->Enabled=true;

   if ((MRingURL = GetDefaultURL(MRingTxt))=="") {
      MRingBox->Checked=false; MRingBox->Enabled=false;
   } else MRingBox->Enabled=true;

   if ((MTyp2URL = GetDefaultURL(MTyp2Txt))=="" || ErrorCheck->Checked) {
      MTyp2Box->Checked=false; MTyp2Box->Enabled=false;
   } else MTyp2Box->Enabled=true;

   if ((CListURL = GetDefaultURL(CListTxt))=="") {
      CListBox->Checked=false; CListBox->Enabled=false;
   } else CListBox->Enabled=true;
   if ((CRingURL = GetDefaultURL(CRingTxt))=="") {
      CRingBox->Checked=false; CRingBox->Enabled=false;
   } else CRingBox->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::CancelBtnClick(TObject *Sender)
{
   //Cancelled = true;
   TimeOutTimer->Enabled = false;
   Timer1->Enabled = false; Label1->Caption = "";
   OkBtn->Enabled = true;
   HelpBtn->Enabled = true;
   Attended = true;
   if (!GetDocs->Enabled)
   {
      GetDocs->Enabled = true;
      //TabSheet1->Enabled = true;
      Panel3->Enabled = true;
      CancelAnyway = true;
      HttpCli1->Abort();
      return;
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::Timer1Timer(TObject *Sender)
{
   if (Label1->Caption=="") Label1->Caption = Cap; else Label1->Caption = "";
   AppProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::PageControl1Changing(TObject *Sender,
  bool &AllowChange)
{
   if (PageControl1->ActivePage==TabSheet3)
      ActiveControl = DocMemo;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::UrlsBtnClick(TObject *Sender)
{
   if (ManageURLs(this))
   {
      MListCBox->Clear();
      MRingCBox->Clear();
      MTyp2CBox->Clear();
      CListCBox->Clear();
      CRingCBox->Clear();
      AppProcessMessages();
      Sleep(200);
      LoadURLs();
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::SetDocMemo(TRemailerDoc *Doc, bool SaveCur)
{
   int Index=TabSet->TabIndex;
   if (SaveCur && Index>=0 && Index<Tabs->Count && DocMemo->Modified)
   {
      TRemailerDoc *doc = new TRemailerDoc();
      doc->Text = DocMemo->Lines->Text;
      SetDoc(Index,doc);
   }
   DocMemo->Clear();
   if (Doc)
      DocMemo->Lines->Text = Doc->Text;
   DocMemo->Modified = false;
   DocMemo->SelStart = 0;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::TabSetChange(TObject *Sender, int NewTab,
   bool &AllowChange)
{
   SetRedraw(DocMemo,false);
   TRemailerDoc *doc=new TRemailerDoc();
   doc->Text = DocMemo->Lines->Text;
   int Index = TabSet->TabIndex;
   if (Index>=0 && Index<Tabs->Count && DocMemo->Modified)
       SetDoc(Index,doc);

   doc = GetDoc(NewTab);
   DocMemo->Lines->Text = doc ? doc->Text:AnsiString("");
   DocMemo->Modified = false;
   DocMemo->SelStart = 0;
   SetRedraw(DocMemo,true);
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::FormResize(TObject *Sender)
{
   HelpBtn->Left = Width - 92;
   CancelBtn->Left = HelpBtn->Left - 75;
   OkBtn->Left = CancelBtn->Left - 75;
   GetDocs->Left = OkBtn->Left - 75;
   ProgressBar1->Width = GetDocs->Left - 30;
   Label1->Top = Height - 74;
   Label1->Width = Width - 42;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::ErrorCheckClick(TObject *Sender)
{
  if (ErrorCheck->Checked)
  {
     MTyp2CBox->Visible = false;
     MTyp2Box->Checked = false; MTyp2Box->Enabled = false;
     CTyp1Box->Visible = true;
  }
  else
  {
     MTyp2CBox->Visible = true;
     CTyp1Box->Visible = false;
     MTyp2Box->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::CRingBoxClick(TObject *Sender)
{
   if (CRingBox->Checked) CListBox->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::MRingBoxClick(TObject *Sender)
{
   if (MRingBox->Checked) MListBox->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::HelpBtnClick(TObject *Sender)
{
   AnsiString sections;
   TTabSheet *tab = PageControl1->ActivePage;
   if (tab==TabSheet1)
   {
      sections="Remailer\nRemailerUrl";
      if (ErrorCheck->Checked)
      {
         sections += "\nRemailerError";
      }
      OpenHelp(sections,"Remailers & Remailer Documents","Remailer Dialog",NULL);//Application->MainForm);
   }
   else
   if (tab==TabSheet3)
   {
      sections="RemailerError";
      if (ErrorCheck->Checked)
      {
//         sections += "\nRemailerError";
//         if (HasMix()) sections += "\nUpdateMixDocs";
//         if (HasPgp()) sections += "\nUpdateCpkDocs";
//         if (GetAppIni(StatsErrCheck,"").ToIntDef(1)) sections += "\nRemailerClear";
      }
      OpenHelp(sections,"Remailers & Remailer Documents","Remailer Dialog",NULL);//AppMainForm);
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::ProxyBtnClick(TObject *Sender)
{
   if (GetWebProxyInfo(this)) LoadHttpInfo();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::TimeOutTimerTimer(TObject *Sender)
{
   CurTime++;
   if (CurTime>=TimeOut)
   {
      HttpCli1->Abort();
      TimeOutTimer->Enabled = false;
      Timer1->Enabled = false; Label1->Caption = "";
      AppProcessMessages(); Sleep(300);
      switch (MsgBoxHwnd(Handle,
         s("Hi ! I didn't get '"+CurDoc+"'...the connection timed out. The\n")+
         s("server may be down. I'll continue with any remaining docs.\n")+
         s("You may need to try another URL for "+CurDoc+".\n\n")+
         s("Would you like to try again before continuing?"),
         s(CurDoc.UpperCase()+" Timed Out"),
         MB_YESNOCANCEL))
      {
         case IDCANCEL: CancelBtn->Click(); break;
         case IDNO : CurBox->Enabled = false;
         case IDYES: GetBtnClick();
      }
   }
}
//---------------------------------------------------------------------------
TRemailerDoc* __fastcall TRemailerDlg::OpenRemailerDoc(AnsiString &Docname)
{
   if (!FileExists(MixDir()+Docname)) return NULL;
   PageControl1->ActivePage = TabSheet3;

   TRemailerDoc *doc;
   AnsiString md=MixDir();
   // if the doc was not downloaded get it from disk
   int Index=Tabs->IndexOf(Docname);
   if (Index>=0)
   {
      doc = GetDoc(Index);
      if (FileExists(md+Docname)) doc->LoadFromFile(md+Docname);
      AppProcessMessages(); Sleep(200);
   }
   else
   {
      doc = new TRemailerDoc();
      if (FileExists(md+Docname)) doc->LoadFromFile(md+Docname);

      Tabs->AddObject(Docname,NULL);
      TabSet->TabIndex = Tabs->Count-1;
      AppProcessMessages(); Sleep(200);
      SetDoc(Docname,doc);
   }
   // special handling type1 and type2
   if (Docname==MTyp2Txt) MixGenType2(GetDoc(MTyp2Txt),GetDoc(MRingTxt),save);
   //if (Docname==CTyp1Txt) FreshenType1(GetDoc(CTyp1Txt),GetDoc(CRingTxt),save);
   // special handling cpunk keyring
   //if (Docname==CRingTxt && HasPgp()) CpkBlockToKeys(doc);
   // end special
   doc->Modified = false;
   doc->OpenDoc;
   SetDocMemo(doc);
   return doc;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::OpenRemailerDocClick(TObject *Sender)
{
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item) switch (item->Tag)
   {
      case 1: OpenRemailerDoc(MListTxt); break;
      case 2: OpenRemailerDoc(MRingTxt); break;
      case 3: OpenRemailerDoc(MTyp2Txt); break;
      case 4: OpenRemailerDoc(CListTxt); break;
      case 5: OpenRemailerDoc(CRingTxt); break;
      case 6: OpenRemailerDoc(CTyp1Txt); break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::OpenBtnClick(TObject *Sender)
{
   TStringList *files = new TStringList();
   files->Text = OpenChosenDocuments(this);
   if (files->Count) PageControl1->ActivePage = TabSheet3;
   for (int i=0; i<files->Count; i++)
   {
      OpenRemailerDoc(files->Strings[i]);
      AppProcessMessages(); Sleep(200);
   }
   delete files;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerDlg::DeleteBtnClick(TObject *Sender)
{
   TStringList *files = new TStringList();
   files->Text = ClearChosenDocuments(this);
   for (int i=0; i<files->Count; i++)
   {
      AnsiString file = MixDir()+files->Strings[i];
      DeleteFile(file.c_str());
      if (file==mringtxt && MixKeyWin)
      {
         Sleep(100); // clear mixkeywin if open
         MixKeyWin->typlistmod = false;
         MixKeyWin->modified = false;
         MixKeyWin->Close();
      }
      if (file==cringtxt && CpkKeyWin)
      {
         Sleep(100); // clear cpkkeywin if open
         CpkKeyWin->typlistmod = false;
         CpkKeyWin->modified = false;
         CpkKeyWin->Close();
      }
   }
   delete files;
}
//---------------------------------------------------------------------------
