//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#pragma hdrstop

#include "UrlsDlg.h"
#include "Global.h"
#include "FileMan.h"
#include "HelpDlgs.h"
#include "pgpmail.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TUrlsForm *UrlsForm;
//---------------------------------------------------------------------------
bool __fastcall ManageURLs(TForm *Owner)
{
   UrlsForm = new TUrlsForm(Owner);
   bool ok = UrlsForm->Execute();
   delete UrlsForm;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TUrlsForm::TUrlsForm(TComponent* Owner)
  : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner); Top -= 8;
   GetAppData(Memo1->Lines,StatsURLs+PS+MListTxt); Memo1->Modified = false;
   GetAppData(Memo2->Lines,StatsURLs+PS+MRingTxt); Memo2->Modified = false;
   GetAppData(Memo3->Lines,StatsURLs+PS+MTyp2Txt); Memo3->Modified = false;
   GetAppData(Memo4->Lines,StatsURLs+PS+CListTxt); Memo4->Modified = false;
   GetAppData(Memo5->Lines,StatsURLs+PS+CRingTxt); Memo5->Modified = false;

   if (!HasPgp()) TabSheet4->TabVisible = TabSheet5->TabVisible = false;

   Memo2->Font->Name = Memo1->Font->Name;
   Memo2->Font->Size = Memo1->Font->Size;
   Memo3->Font->Name = Memo1->Font->Name;
   Memo3->Font->Size = Memo1->Font->Size;
   Memo4->Font->Name = Memo1->Font->Name;
   Memo4->Font->Size = Memo1->Font->Size;
   Memo5->Font->Name = Memo1->Font->Name;
   Memo5->Font->Size = Memo1->Font->Size;

   PageControl1->ActivePage = TabSheet1;
   ActiveControl = Memo1;
   SavedURLs = false;
}
//---------------------------------------------------------------------------
void __fastcall TUrlsForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (!URLsModified()) return;
   if (ModalResult==mrCancel)
   {
      switch (MsgBoxHwnd(Handle,
        "Your URLs have been modified.\n\nSave your changes?","Confirm",MB_YESNOCANCEL))
      {
         case IDCANCEL: CanClose = false; break;
         case IDYES: SaveURLs(); break;
      }
      return;
   }
   SaveURLs();
}
//---------------------------------------------------------------------------
bool __fastcall TUrlsForm::URLsModified()
{
   return Memo1->Modified||Memo2->Modified||Memo3->Modified||
      Memo4->Modified||Memo5->Modified;
}
//---------------------------------------------------------------------------
void __fastcall DumpNulls(TStrings *items)
{
}
//---------------------------------------------------------------------------
void __fastcall TUrlsForm::SaveDocURLs(AnsiString &DocName, TStrings *URLs)
{
   int i=0; while (i<URLs->Count)
   {
      if (URLs->Strings[i].Trim().IsEmpty()) URLs->Delete(i);
      else i++;
   }
   PutAppData(StatsURLs+PS+DocName,URLs);
}
//---------------------------------------------------------------------------
bool __fastcall TUrlsForm::Execute()
{
   ShowModal();
   return SavedURLs;
}
//---------------------------------------------------------------------------
void __fastcall TUrlsForm::SaveURLs()
{
   if (Memo1->Modified) SaveDocURLs(MListTxt,Memo1->Lines);
   if (Memo2->Modified) SaveDocURLs(MRingTxt,Memo2->Lines);
   if (Memo3->Modified) SaveDocURLs(MTyp2Txt,Memo3->Lines);
   if (Memo4->Modified) SaveDocURLs(CListTxt,Memo4->Lines);
   if (Memo5->Modified) SaveDocURLs(CRingTxt,Memo5->Lines);
   SavedURLs = true;
}
//---------------------------------------------------------------------------
void __fastcall TUrlsForm::PageControl1Change(TObject *Sender)
{
   SetRedraw(PageControl1,0);
   AppProcessMessages()
   if (PageControl1->ActivePage==TabSheet1) ActiveControl = Memo1; else
   if (PageControl1->ActivePage==TabSheet2) ActiveControl = Memo2; else
   if (PageControl1->ActivePage==TabSheet3) ActiveControl = Memo3; else
   if (PageControl1->ActivePage==TabSheet4) ActiveControl = Memo4; else
   if (PageControl1->ActivePage==TabSheet5) ActiveControl = Memo5;
   AppProcessMessages()
   SetRedraw(PageControl1,1);
}
//---------------------------------------------------------------------------
/*
void __fastcall TUrlsForm::SetDefaultUrlFromCursor(TMemo *memo)
{
   if (!memo) return;
   int idx = memo->Perform(EM_LINEFROMCHAR,(WORD)memo->SelStart,0);
   if (idx>=1 && idx<memo->Lines->Count)
   {
      memo->Lines->Insert(0,"");
      Application->ProcessMessages();
      Sleep(200);
      AnsiString line = memo->Lines->Strings[idx+1];
      memo->Lines->Strings[idx+1] = "";
      Application->ProcessMessages();
      Sleep(200);
      memo->Lines->Strings[0] = line;
      Application->ProcessMessages();
      Sleep(200);
      memo->Lines->Delete(idx+1);
      Application->ProcessMessages();
      Sleep(200);
      memo->SelStart = 0;
   }
}
*/
void __fastcall TUrlsForm::SetDefaultUrlFromCursor(TMemo *memo)
{
   if (!memo) return;
   int idx = memo->Perform(EM_LINEFROMCHAR,(WORD)memo->SelStart,0);
   if (idx>=1 && idx<memo->Lines->Count)
   {
      memo->Lines->Insert(0,"");
      AnsiString line = memo->Lines->Strings[idx+1];
      for (int i=1; i<=line.Length(); i++)
      {
         memo->Lines->Strings[idx+1] = line.SubString(i,64);
         memo->Lines->Strings[0] = line.SubString(1,i);
         Sleep(0);
      }
      memo->Lines->Delete(idx+1);
      memo->SelStart = 0;
   }
}

//---------------------------------------------------------------------------
void __fastcall TUrlsForm::MemoDblClick(TObject *Sender)
{
   SetDefaultUrlFromCursor(dynamic_cast<TMemo*>(Sender));
}
//---------------------------------------------------------------------------
void __fastcall TUrlsForm::HeplBtnClick(TObject *Sender)
{
   OpenHelp("RemailerUrl","Remailer Documents URLs","URL Manager",Application->MainForm);

}
//---------------------------------------------------------------------------